# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free
%define jaxbver  2.1

Name:           sun-jaxb-2.1-impl
Version:        2.1.6
Release:        1jpp
Epoch:          0
Summary:        JAXB Reference Implementation
License:        CDDL
Url:            https://jaxb2-sources.dev.java.net/
Source0:        sun-jaxb-2.1-impl-2.1.6.tar.gz
# cvs -d:pserver:guest@cvs.dev.java.net:/cvs export -r jaxb-2_1_4 -d sun-jaxb-2.1-impl-2.1.4 jaxb2-sources/jaxb-ri

Source1:        http://download.java.net/maven/1/com.sun.xml.bind/poms/jaxb-impl-2.1.6.pom
Source2:        jaxb-xjc-2.1.6.pom
# Patch to use original xml-commons-resolver11 (?)
Patch0:         sun-jaxb-2.1-impl-Options.patch
Patch1:         sun-jaxb-2.1-impl-build-taskdefs.patch

Group:          Development/Libraries/Java
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
BuildRequires:  jpackage-utils >= 0:1.7.4
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  antlr
BuildRequires:  args4j10
BuildRequires:  dom4j
BuildRequires:  isorelax
BuildRequires:  jaf_1_1_api
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-jelly
BuildRequires:  jakarta-commons-jelly-tags-util
BuildRequires:  javamail_1_4_api
BuildRequires:  javatools-package-rename-task
BuildRequires:  jing >= 0:0.1-0.20030619.9jpp
BuildRequires:  jsp_2_1_api
BuildRequires:  msv-msv
BuildRequires:  msv-xsdlib
BuildRequires:  relaxngcc
BuildRequires:  relaxngDatatype
BuildRequires:  rngom
BuildRequires:  servlet_2_5_api
BuildRequires:  stax_1_0_api
BuildRequires:  stax-ex >= 0:1.2
BuildRequires:  sun-codemodel
BuildRequires:  sun-dtdparser
BuildRequires:  sun-fi >= 0:1.2.2
BuildRequires:  sun-htmlmacro
BuildRequires:  sun-istack-commons >= 1:1.0
BuildRequires:  sun-jaxb-1.0-impl
BuildRequires:  sun-jaxb-2.1-api
BuildRequires:  sun-txw2
BuildRequires:  sun-txw2-compiler
BuildRequires:  sun-xsom
BuildRequires:  xml-commons-resolver11

Requires:  java >= 0:1.5.0
Requires:  ant
Requires:  antlr
Requires:  dom4j
Requires:  isorelax
Requires:  jaf_1_1_api
Requires:  javamail_1_4_api
Requires:  jsp_2_1_api
Requires:  msv-msv
Requires:  relaxngDatatype
Requires:  servlet_2_5_api
Requires:  stax_1_0_api
Requires:  stax-ex >= 0:1.2
Requires:  sun-fi >= 0:1.2.2
Requires:  sun-jaxb-2.1-api
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif
Requires(post):    jpackage-utils >= 0:1.7.4
Requires(postun):  jpackage-utils >= 0:1.7.4

%description
The Java Architecture for XML Binding (JAXB) 2.1
Reference Implementation from Sun.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%package demo
Summary:        Samples for %{name}
Group:          Development/Java

%description demo
%{summary}.

%prep
%setup -q
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

ln -sf $(build-classpath jing) tools/lib/util/jing.jar
ln -sf $(build-classpath sun-txw2) tools/lib/rebundle/runtime2/txw2.jar
ln -sf $(build-classpath sun-txwc2) tools/lib/util/txwc2.jar
#ln -sf $(build-classpath sun-htmlmacro) tools/htmlmacro/htmlmacro.jar
mv tools/htmlmacro/htmlmacro.jar.no tools/htmlmacro/htmlmacro.jar
#ln -sf $(build-classpath commons-collections) tools/htmlmacro/commons-collections.jar
#ln -sf $(build-classpath jelly-tags/commons-jelly-tags-util) tools/htmlmacro/commons-jelly-tags-util-1.1.1.jar
mv tools/htmlmacro/commons-jelly-tags-util-1.1.1.jar.no tools/htmlmacro/commons-jelly-tags-util-1.1.1.jar
ln -sf $(build-classpath sun-dtdparser) tools/lib/rebundle/compiler/dtd-parser-1.0.jar
ln -sf $(build-classpath xml-commons-resolver11) tools/lib/rebundle/compiler/resolver.jar
ln -sf $(build-classpath stax-ex) tools/lib/util/stax-ex.jar
ln -sf $(build-classpath args4j10) tools/lib/util/args4j-1.0-RC.jar
ln -sf $(build-classpath javatools-package-rename-task) tools/lib/util/package-rename-task.jar
ln -sf $(build-classpath rngom) tools/lib/rebundle/compiler/rngom.jar
ln -sf $(build-classpath sun-codemodel) tools/lib/rebundle/compiler/codemodel.jar
ln -sf $(build-classpath sun-codemodel-annotation-compiler) tools/lib/util/codemodel-annotation-compiler.jar
ln -sf $(build-classpath sun-istack-commons/tools) tools/lib/rebundle/compiler/istack-commons-tools.jar
ln -sf $(build-classpath sun-istack-commons/runtime) tools/lib/rebundle/runtime2/istack-commons-runtime.jar
ln -sf $(build-classpath sun-xsom/xsom) tools/lib/rebundle/compiler/xsom.jar
ln -sf $(build-classpath sun-fi) tools/lib/util/FastInfoset.jar
ln -sf $(build-classpath stax_1_0_api) tools/lib/redist/jsr173_1.0_api.jar
ln -sf $(build-classpath jaxb_2_1_api) tools/lib/redist/jaxb-api.jar
ln -sf $(build-classpath relaxngDatatype) tools/lib/rebundle/runtime/relaxngDatatype.jar
ln -sf $(build-classpath isorelax) tools/lib/rebundle/runtime/isorelax.jar
ln -sf $(build-classpath msv-msv) tools/lib/rebundle/runtime/msv.jar
ln -sf $(build-classpath xsdlib) tools/lib/rebundle/runtime/xsdlib.jar
ln -sf $(build-classpath jaf_1_1_api) tools/lib/redist/activation.jar
ln -sf $(build-classpath relaxngcc) tools/lib/util/relaxngcc.jar
ln -sf $(build-classpath sun-jaxb-1.0/xjc.jar) tools/compiler10/jaxb1-xjc.jar

%patch0 -b .sav0
%patch1 -b .sav1

%build
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
export OPT_JAR_LIST="ant-launcher"
ant dist

export CLASSPATH=$(build-classpath \
antlr \
javamail_1_4_api \
jsp_2_1_api \
servlet_2_5_api \
)
CLASSPATH=$CLASSPATH:$(pwd)/dist/lib/jaxb-xjc.jar
CLASSPATH=$CLASSPATH:$(pwd)/dist/lib/jaxb1-impl.jar

pushd tools

pushd jing-rnc-driver
ant jar
popd

pushd pretty-printer
ant jar
popd

pushd taglets
ant jar
popd

pushd webapp-commons
ant jar
popd

pushd xmllint
ant jar
popd

popd

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/sun-jaxb-2.1-tools
install -m 644 dist/lib/jaxb-impl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/lib/jaxb-xjc.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-xjc-%{version}.jar
%add_to_maven_depmap com.sun.xml.bind jaxb-impl %{version} JPP %{name}
%add_to_maven_depmap com.sun.xml.bind jaxb-xjc %{version} JPP %{name}-xjc

install -m 644 tools/jing-rnc-driver/build/jing-rnc-driver.jar $RPM_BUILD_ROOT%{_javadir}/sun-jaxb-2.1-tools/jing-rnc-driver-%{version}.jar
install -m 644 tools/pretty-printer/build/pretty-printer.jar $RPM_BUILD_ROOT%{_javadir}/sun-jaxb-2.1-tools/pretty-printer-%{version}.jar
install -m 644 tools/taglets/build/taglets.jar $RPM_BUILD_ROOT%{_javadir}/sun-jaxb-2.1-tools/taglets-%{version}.jar
install -m 644 tools/xmllint/build/xmllint.jar $RPM_BUILD_ROOT%{_javadir}/sun-jaxb-2.1-tools/xmllint-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/sun-jaxb-2.1-tools && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
touch $RPM_BUILD_ROOT%{_javadir}/jaxb_2_1_impl.jar
touch $RPM_BUILD_ROOT%{_javadir}/jaxb_impl.jar

# scripts
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 dist/bin/schemagen.sh $RPM_BUILD_ROOT%{_bindir}/sun-jaxb-schemagen
install -m 755 dist/bin/xjc.sh $RPM_BUILD_ROOT%{_bindir}/sun-jaxb-xjc

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -pm 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-xjc.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf dist/docs/api

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr dist/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 CDDL+GPLv2.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 CDDL+GPLv2.html $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


# samples
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr dist/samples $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi


%post
%update_maven_depmap
/usr/sbin/update-alternatives --install %{_javadir}/jaxb_2_1_impl.jar jaxb_2_1_impl %{_javadir}/%{name}.jar 20100
/usr/sbin/update-alternatives --install %{_javadir}/jaxb_impl.jar jaxb_impl %{_javadir}/%{name}.jar 20100
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
if [ "$1" = "0" ]; then
    /usr/sbin/update-alternatives --remove jaxb_2_1_impl %{_javadir}/%{name}.jar
    /usr/sbin/update-alternatives --remove jaxb_impl %{_javadir}/%{name}.jar
fi

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/CDDL+GPLv2.txt
%{_javadir}/%{name}*.jar
%{_javadir}/sun-jaxb-2.1-tools
%attr(755,root,root) %{_bindir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif
%ghost %{_javadir}/jaxb_2_1_impl.jar
%ghost %{_javadir}/jaxb_impl.jar


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%changelog
* Tue Apr 08 2008 Ralph Apel <r.apel at r-apel.de> - 0:2.1.6-1jpp
- 2.1.6

* Tue Mar 11 2008 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-1jpp
- First release

